#!/bin/sh

# This script takes down the ppp device via ip command and renames it.
# Be careful, routing information must be reset afterwards!
# 
# pppd environment variables
#
# $DEVICE
# The name of the serial tty device being used. 
# $IFNAME
# The name of the network interface being used. 
# $IPLOCAL
# The IP address for the local end of the link. This is only set when IPCP has come up. 
# $IPREMOTE
# The IP address for the remote end of the link. This is only set when IPCP has come up. 
# $PEERNAME
# The authenticated name of the peer. This is only set if the peer authenticates itself. 
# $SPEED
# The baud rate of the tty device. 
# $ORIG_UID
# The real user-id of the user who invoked pppd. 
# $PPPLOGNAME
# The username of the real user-id that invoked pppd. This is always set. 
# CONNECT_TIME
# The number of seconds from when the PPP negotiation started until the connection was terminated. 
# BYTES_SENT
# The number of bytes sent (at the level of the serial port) during the connection. 
# BYTES_RCVD
# The number of bytes received (at the level of the serial port) during the connection. 
# LINKNAME
# The logical name of the link, set with the linkname option. 
# DNS1
# If the peer supplies DNS server addresses, this variable is set to the first DNS server address supplied. 
# DNS2
# If the peer supplies DNS server addresses, this variable is set to the second DNS server address supplied.

if [ "$LINKNAME" == "l2tp-ppp" ]
then
	ip link set $IFNAME down
	for i in `seq 0 999`
	do
		IF_NAME=$LINKNAME$i
		ip link set $IFNAME name $IF_NAME

		if [ "$?" -eq "0" ]
		then
			ip link set $IF_NAME up
			# dnsmasq instance for l2tp classless static routes (RFC 3442)
			#killall -9 dnsmasq
			#dnsmasq -C /etc/dnsmasq.conf --except-interface=lo --interface=$IF_NAME
		fi
	done
fi
